' #############################################
'
'  Erstellen einer Html Datei, in der alle Backups aufgelsitet sind
'
'  Author:		uws
'  Company:	INFO AG
'  Phone:		0208-833 1421
'  Mail:		uwe.schimanski@info-ag.de
'  Date:		09-Apr-2009
'
' #############################################

Option Explicit

' ###################################
' Bibliothek zum Aufrufen von Programmen,Verzeichnissen
' und Dateien und zum Handling des Netzwerkes
' ###################################

Dim WshShell, FSO, WshNetwork, objShell

Set WshShell = WScript.CreateObject("WScript.Shell") ' Programme

Set FSO = CreateObject("Scripting.FileSystemObject") ' Verzeichnisse

Set objShell = CreateObject("WScript.Shell")

Set WshNetwork = WScript.CreateObject("WScript.Network") ' Netzwerk

' ###################################
' Hier geht es mit dem Programm los
' ###################################

Dim StartMain, EndMain
Dim DateTimeString
Dim strLogName, strLogPath, LogFile
Dim strWorkingPath, strProjName
Dim strCompany, intVersion, strMail, strBy

StartMain = Now

'On Error Resume Next

' ###################################
'  			HTML Seite erstellen.
' ###################################

Dim strIniDB, strReadIniDB, strPathLogDB, strListFileDRV, strDB, strPathLog
Dim objStart, objFolder, objDateiCP, objStartFolder, strSourceLogPath, strBackupFileShare

strLogPath = "d:\Oracle\Product\10.2.0\Backup\" 	' Hier wird die HTML-Seite erstellt / abgelegt.
strLogName = strLogPath & "\Index.html"				' Name der HTML Datei.
strPathLog="d:\Oracle\Product\10.2.0\Backup\DBLog\" ' Hier sind die DB-Log Files zum auswerten.
strIniDB="db.ini" 									' Alle Oracle DB'S stehen in diesem File
strSourceLogPath="b:\rman_log\" 					' Hier werden die Logfiles vom Backup der DB's abgelegt.

LogFileHeader

Set strReadIniDB = FSO.OpenTextFile(strIniDB)

Do Until strReadIniDB.AtEndOfStream

	strDB = strReadIniDB.ReadLine
	strPathLogDB = strPathLog & strDB

	If strDB = "" then
		Wscript.Quit
	End If
	
	If FSO.FolderExists(strPathLogDB) Then
    	' Verzeichnis vorhanden, alles bestens.
	Else
		' Fehlende Verzeichnisse werden angelegt.
    	Set objFolder = FSO.CreateFolder(strPathLogDB)
    	Set objFolder = FSO.CreateFolder(strPathLogDB & "\Log")
    End If		

	strPathLogDB = strPathLog & strDB & "\Log"
	
	' Alle Dateien lschen, es werden nur die neuen Logs ausgewertet.
	'Wscript.echo strPathLogDB
	
	FSO.CreateTextFile (strPathLogDB & "\dbrm.log")				' Damit es keine Fehlermeldung gibt, wird erstmal eine Datei erzeugt.
	FSO.DeleteFile (strPathLogDB & "\*.log")					' Nun geht es an das lschen.
	
	' Holen der neuen Dateien

	strBackupFileShare=strSourceLogPath & strDB & "\Backup.txt"
	
	If FSO.FileExists(strBackupFileShare) = True Then
		' Da machen wir mal nichts
	Else
		WshNetwork.MapNetworkDrive "b:", "\\deoby003\cdbvault$"
	End If

	set objStartFolder = FSO.GetFolder(strSourceLogPath & strDB & "\")
	
	If FSO.FileExists(strBackupFileShare) = True Then
		For Each objDateiCP in objStartFolder.Files
			FSO.CopyFile strSourceLogPath & strDB & "\" & objDateiCP.Name, strPathLogDB & "\", True
		Next
		FSO.DeleteFile (strBackupFileShare)
	End If

'	If FSO.FileExists(strBackupFileShare) = True Then
'		FSO.DeleteFile (strBackupFileShare)
'	End If

	WshNetwork.RemoveNetworkDrive "b:"
	
	Set objStart = FSO.GetFolder(strPathLogDB)
	ListFiles objStart, 0
	
Loop

LogFileEnd 

LogFile.Close

EndMain = Now

' ###################################
'  			Logfile Header schreiben
' ###################################

Sub LogFileHeader

'DateTimeString = CStr(DateDiff("s", "1.1.1970", StartMain))
DateTimeString = CStr(DateDiff("m", "1.1.1970", StartMain))

strCompany = "INFO AG"
strMail = "uwe.schimanski@info-ag.de"
strBy = "Uwe Schimanski"
intVersion = "1.0.2"

Set strWorkingPath = FSO.GetFile(WScript.ScriptFullName).ParentFolder.ParentFolder
 
Set LogFile = FSO.CreateTextFile(strLogName, True)

	LogFile.WriteLine "<html>"
	LogFile.WriteLine
	LogFile.WriteLine "<head>"
	LogFile.WriteLine "<title> Backup der Oracle Datenbanken fuer die HPE</title>"
	LogFile.WriteLine "</head>"
	LogFile.WriteLine "<body>"
	LogFile.WriteLine "<table>"
	LogFile.WriteLine "  <colgroup width=""200"" span=""2""><colgroup width=""500"" span=""1""><colgroup width=""200"" span=""1"">"
	LogFile.WriteLine "  </colgroup>"
	LogFile.WriteLine " <tr>"
	LogFile.WriteLine "  <td><p><left><img src=""info.gif"" alt=""Logo der INFO AG""></left></td>"
	LogFile.WriteLine "  <td></td>"
	LogFile.WriteLine "  <td><h3><valign=""middle""><center><font face=""Arial"">Backup der Oracle Datenbanken.</p></font></h3></valign></center></td>"
	LogFile.WriteLine "  <td><h3><valign=""middle""><center><font face=""Arial"">" & Date & "</center></valign></font></h3></td>"
	LogFile.WriteLine " </tr>"
	LogFile.WriteLine "</table>"
	LogFile.WriteLine "<hr width=""100%"" size=""1""> </hr>"
'	LogFile.WriteLine ("<p><object data=""rman_arch_cae01_2009_04_05_22_15_01.log"" type=""text/plain"" width=""1000"" height=""400""</object></p>")
'	LogFile.WriteLine ("<p><a href=""cae01/rman_arch_cae01_2009_04_05_22_15_01.log"">2009_04_05</a></p>")

End Sub

Sub LogFileEnd

	'LogFile.WriteLine "<br>"
	'LogFile.WriteLine "<br>"
	'LogFile.WriteLine "<br>"
	LogFile.WriteLine "<br>"
	LogFile.WriteLine "<br>"
	LogFile.WriteLine "<hr width=""100%"" size=""1""> </hr>"
	LogFile.WriteLine "<br>"
	LogFile.WriteLine "<h6><font face=""Arial""><p>By: Uwe Schimanski - INFO AG</p>"
	LogFile.WriteLine "<p>Diese Seite wird automatisch erstellt.</p></h6></font>"
	LogFile.WriteLine "</body>"
	LogFile.WriteLine "</html>"

End Sub

Sub ListFiles(ByVal objOrdner, byVal intEinrueck)

' Hier erfolgt die Auswertung der Log-Files.
' 1. berprfen, ob es aktuelle Logfiles gibt.
'	 Hierzu wird im Log-Verzeichnis bei einem erfolgreichen Backup die Datei Backup.txt erstellt.
'	 Ist die Datei vorhanden, wird sie gelscht und es geht weiter mit 2.
' 2. ffnen aller Log-Files und suchen nach dem String RMAN-00
' 3. Bei einem Fund des Strings, Ausgabe des Dateinamens und den Inhalt in der HTML Datei.
' 4. Gibt es keinen Fund, Meldung ausgeben, da das Backup ohne Fehler gelaufen ist.

Dim objDatei, objFile, currentfile, strBackupFile, objDBLogFile, strCharacters, strLine, arrLines
Dim strCheckForString, strErrorCode, strDBLog

	LogFile.WriteLine "<h4><u><font face=""Arial""<p>Datenbank " & strDB &"</font></h4></u></p>"

strBackupFile=strPathLogDB & "\Backup.txt"
strCheckForString = UCase("RMAN-00")

If FSO.FileExists(strBackupFile) = True Then
	
	FSO.DeleteFile(strBackupFile)
	LogFile.WriteLine " <font face=""Arial""<p>Folgende Log-Files wurden analysiert:</font></p>"
	
	For Each objDatei in objOrdner.files
		If LCase(FSO.GetExtensionName(objDatei.name)) = "log" then
			Set objDBLogFile = FSO.OpenTextFile(strPathLogDB & "\" & objDatei.name, 1)
			set currentfile = FSO.GetFile(strPathLogDB & "\" & objDatei.name)
			LogFile.WriteLine " <p><a href=""" & "DBLog/" & strDB & "/Log/" & objDatei.name & """>" & objDatei.name & "</a></p>"
			'LogFile.WriteLine " <p><a target = ""_blank"" href=""//dude072/OraBack$/DBLog/" & strDB & "/log/" & objDatei.name & """>" & objDatei.name & "</a></p>"
				
			IF (currentfile.size > 0) then
				
				strCharacters = objDBLogFile.ReadAll
				strErrorCode = "0"
				arrLines = Split(strCharacters, vbNewLine)
				
				For Each strLine In arrLines
					If strErrorCode = "0" then
						If (Left(UCase(LTrim(strLine)),Len(strCheckForString)) = strCheckForString) Then  
							LogFile.WriteLine " <font color=""FF0000""><strong>RMAN-Error gefunden! </font</strong><br>"
							LogFile.WriteLine " <font color=""FF0000""><strong>Bitte den Log-File analysieren. </font></strong><br>"
							strErrorCode = "1"
						End If
					End If
				Next
				
				If Not strErrorCode = "1" Then
					LogFile.WriteLine " Keine RMAN-Errors gefunden. Backup war erfolgreich.<br>"
				End If
				
			End If
		End if
	Next
Else
	LogFile.WriteLine " <font color=""FF0000""> Es wurden keine Log-Files gefunden. </font><br>"
	LogFile.WriteLine " <font color=""FF0000""> Backup der Datenbank ist nicht erfolgt! </font><br>"
End if

End Sub
	
